#include "soapH.h"
#include "echo.nsmap"

int  cnt,
     num = 1,
     soapio = 0;
char  *server;

int main (int argc, char **argv)
{
   struct soap  soap;
   char  *cptr, *result;

   if (!(server = getenv("ECHO_URL")))
   {
      fprintf (stderr, "Requires: $ ECHO_URL = \"http://the.host.name/the/path\"\n");
      exit (0);
   }
   if (argc < 2)
   {
      fprintf (stderr, "Usage: echoclient \"<string>\"\n");
      exit (0);
   } 
   if (argc >= 3) num = atoi(argv[2]);
   if (argc >= 4 && (*(unsigned short*)(argv[3]) == '-k' ||
                     *(unsigned short*)(argv[3]) == '+k'))
      soapio |= SOAP_IO_KEEPALIVE;

   fprintf (stderr, "%s\n", server);
   for (cnt = 0; cnt < num; cnt++)
   {
      if (!cnt || !soapio) soap_init1 (&soap, soapio);

      soap_call_ns__echo (&soap, server, "", argv[1], &result);

      if (soap.error)
      {
         if (num > 1) fprintf (stderr, "%d/%d:\n", cnt, num);
         soap_print_fault (&soap, stderr);
         exit(1);
      }
      else
         printf ("%s\n", result);

      if (!soapio)
      { 
         /* if not keep-alive */
         soap_destroy (&soap);
         soap_end (&soap);
         soap_done (&soap);
      }
   }

   return (0);
}
